
--
-- Sharpliner digital demo
-- (c) 11/2009 ASkr, www.askrprojects.net
--
-- Features a PISS interface ;)
-- Primitive Interconnect Serial Solution
-- Faster than I2C ;)
--


-- choose your Sharpliner port, here...
port=1


------------------------------------------------------------------------------------------------------------
-- uWait()
--
-- Waits (blocks) for ~<c> us.
-- Minimum value is ~80us
-- Use this while in a nxt.DisableNXT(1) <-> nxt.DisableNXT(0) loop!
-----------------------------------------------------------------------------------------------------------
function uWait(c)
	local i
	c=c*10
	c=(c/24)-32
	for i=1,c do
	end
end



------------------------------------------------------------------------------------------------------------
-- utilWait()
--
-- Waits (blocks) for <tim> ms.
-----------------------------------------------------------------------------------------------------------
function utilWait(tim)
	local stim=nxt.TimerRead()
	repeat
	until nxt.TimerRead() > stim+tim
end



------------------------------------------------------------------------------------------------------------
-- Init(port)
--
-- 
-----------------------------------------------------------------------------------------------------------
function Init()
	nxt.InputSetType(port,0)
	nxt.InputSetDir(port,1,0)			-- DIG0 CLK(out), DIG1 DATA(in)
	nxt.InputSetState(port,1,nil)
end



------------------------------------------------------------------------------------------------------------
-- Meas()
--
-- Get measurement values from #<sensors> Sharpliner sensors.
-- The result is written to a table (size of <sensors>).
-----------------------------------------------------------------------------------------------------------
function Meas(sensors)

	local i,j,k,l
	local dat={}

	nxt.DisableNXT(1)

	-- arm the counter interrupts
	nxt.InputSetState(port,0,nil)
	uWait(350);
	nxt.InputSetState(port,1,nil)
	uWait(80);

	-- start the protocol
	for j=1,sensors do
		l=0
		for i=1,11 do
			l=l/2
			nxt.InputSetState(port,0,nil)
			nxt.InputSetState(port,1,nil)
			_,_,k=nxt.InputGetStatus(port)
			if k==1 then
				l=l+0x200
			end
		end
		dat[j]=l
	end

	nxt.DisableNXT(0)
		
	return dat

end



------------------------------------------------------------------------------------------------------------
-- go(sensors)
--
-- start here...
-- <sensors>: number of sensors to query
-- This will display the Sharpliner sensor values on the NXT screen and terminal.
-- Note: More than 3 values will not fit into a single NXT display line.
-- Pushing the orange button will stop the app.
-----------------------------------------------------------------------------------------------------------
function go(sensors)
	local dat,i,sval

	Init(port)
	
	while nxt.ButtonRead()==0 do
	
		dat=Meas(sensors)
		sval=""
		for _,i in pairs(dat) do
			sval=sval..string.format("%04d ",i)
		end

		print(sval)
		nxt.DisplayText(sval)
		nxt.DisplayScroll()

		utilWait(333)
	
	end -- end while
end

